%define anolis_release 1

# disable debug info generation
%define debug_package %{nil}
# skip strip due to lacking of bpf support
%global __brp_strip %{nil}
%global __brp_strip_lto %{nil}

Name:        vtoa
Version:     2.1.1
Release:     %{anolis_release}%{?dist}
Summary:     vtoa for Alibaba Cloud
License:     Mulan PSL v2
Vendor:      Alibaba
URL:         N/A
Source0:     %{name}-%{version}.tar.gz

BuildArch:   x86_64 aarch64

Requires:    glibc

%description
vtoa supports cloud service server to get vid:vip:vorpt and cip:cport, compatible with toa. Kernel version must be no less than 5.10-017.
Maintained by Alibaba Cloud kernel networking Team.

%prep
%autosetup -n %{name}-%{version} -p1

%build
# There is noting to build.

%install
mkdir -p %{buildroot}/%{_datadir}/%{name}
pwd
%ifarch aarch64
cp -r aarch64/* %{buildroot}/
%endif
%ifarch x86_64
cp -r x86_64/* %{buildroot}/
%endif

%files
%dir %{_datadir}/%{name}
%{_bindir}/vtoa
%{_datadir}/%{name}/vtoa.kern.o
%{_datadir}/%{name}/vtoa.kern.old.o
%{_datadir}/%{name}/vtoa.kern.kfunc.o
%{_datadir}/%{name}/manage.sh
%{_sysconfdir}/systemd/system/%{name}.service
%{_sysconfdir}/modprobe.d/%{name}.conf

%{_datadir}/%{name}/LICENSE

%post
if [ $1 -eq 1 ] ; then
    # install, not upgrade
    systemctl start vtoa
    systemctl enable vtoa
fi

%preun
if [ $1 -eq 0 ] ; then
    # uninstall, not upgrade
    systemctl stop vtoa
    systemctl disable vtoa
fi

%postun
if [ $1 -eq 1 ] ; then
    # upgrade, not uninstall
    systemctl daemon-reload
    systemctl restart vtoa
    systemctl reenable vtoa
fi

%changelog
* Mon Jun 30 2025 Philo Lu <lulie@linux.alibaba.com> - 2.1.1-1
- Fix HYBRID_VTOA_SO_GET_VS sockopt fails for ipv4.
- Fix unexpected error returned by getsockopt with large optlen.
- Better log format.
- Other minor fixes.

* Tue Apr 15 2025 Philo Lu <lulie@linux.alibaba.com> - 2.1.0-2
- Fix unexpected error when rpm upgrading.

* Tue Mar 25 2025 Philo Lu <lulie@linux.alibaba.com> - 2.1.0-1
- Add new toa type support: 254 + ipv6.
- Add modprobe support for vtoa-bpf.
- Add support for kernel 6.6 (kfunc).

* Tue Jun 18 2024 hanqi <lulie.ll@alibaba-inc.com> - 2.0.1-1
- Add vtoa.ko into systemctl too. Now systemctl manages both vtoa-bpf and vtoa.ko, with automatic kernel version checking.

* Wed May 22 2024 hanqi <lulie.ll@alibaba-inc.com> - 2.0.0-1
- Init package from anolis release
